part of query;

/// A 'logical and' expression of two or more expressions
class And extends Expression {
  /// List of expressions composing this 'logical and' expression
  final List<Expression> _expressions = [];

  And();

  /// List of expressions composing this 'logical and' expression
  List<Expression> get expressions => _expressions.toList();

  /// Number of expressions composing this 'logical and' expression
  int get length => _expressions.length;

  /// Creates a 'logical and' expression of this expression and the [other]
  And and(Expression exp) {
    if (exp is And) {
      _expressions.addAll(exp._expressions);
    } else {
      _expressions.add(exp);
    }

    return this;
  }

  /// Creates a 'logical or' expression of this expression and the [other]
  Or or(Expression exp) {
    Or ret = new Or();

    return ret.or(this).or(exp);
  }

  String toSql() => _expressions.map((Expression exp) {
        StringBuffer sb = new StringBuffer();

        if (exp.length != 1) {
          sb.write('(');
        }

        sb.write(exp.toSql());

        if (exp.length != 1) {
          sb.write(')');
        }

        return sb.toString();
      }).join(' AND ');
}
